## zcfan 1.2.1

=== Makefile ===
CFLAGS:=-std=gnu99 -O2 -pedantic -Wall -Wextra -Werror $(CFLAGS)

SOURCES=$(wildcard *.c)
EXECUTABLES=$(patsubst %.c,%,$(SOURCES))

INSTALL:=install
prefix:=/usr/local
bindir:=$(prefix)/bin
datarootdir:=$(prefix)/share
mandir:=$(datarootdir)/man

all: $(EXECUTABLES)

%: %.c
	$(CC) $(CFLAGS) $< -o $@ $(LIBS) $(LDFLAGS)

%.o: %.c
	$(CC) $(CFLAGS) $< -c -o $@

%: %.o
	$(CC) $< -o $@ $(LIBS) $(LDFLAGS)

# Noisy clang build that's expected to fail, but can be useful to find corner
# cases.
clang-everything: CC=clang
clang-everything: CFLAGS+=-Weverything -Wno-disabled-macro-expansion -Wno-padded -Wno-covered-switch-default -Wno-gnu-zero-variadic-macro-arguments
clang-everything: all

sanitisers: CFLAGS+=-fsanitize=address -fsanitize=undefined
sanitisers: debug

debug: CFLAGS+=-Og -ggdb -fno-omit-frame-pointer
debug: all

clang-tidy:
	# DeprecatedOrUnsafeBufferHandling: See https://stackoverflow.com/a/50724865/945780
	# clang-diagnostic-gnu-zero-variadic-macro-arguments: We require this for ##__VA_ARGS__
	clang-tidy zcfan.c -checks=-clang-analyzer-security.insecureAPI.DeprecatedOrUnsafeBufferHandling,-clang-diagnostic-gnu-zero-variadic-macro-arguments -- $(CFLAGS) $(LDFLAGS)

install: all
	mkdir -p $(DESTDIR)$(bindir)/
	$(INSTALL) -pt $(DESTDIR)$(bindir)/ $(EXECUTABLES)
	$(INSTALL) -Dp -m 644 zcfan.service $(DESTDIR)$(prefix)/lib/systemd/system/zcfan.service
	$(INSTALL) -Dp -m 644 zcfan.1 $(DESTDIR)$(mandir)/man1/zcfan.1

clean:
	rm -f $(EXECUTABLES)

=== debian/changelog ===
zcfan (1.2.1-2) unstable; urgency=medium

  * Mark as conflicting with thinkfan (Closes: #1017980)
  * Update Standards-Version to 4.6.2
  * Don't enable by default, like thinkfan (Closes: #1032418)
  * Workaround for dh_installsystemd (Closes: #1034228)

 -- Michel Alexandre Salim <michel@michel-slm.name>  Thu, 27 Apr 2023 16:52:29 -0500

zcfan (1.2.1-1) unstable; urgency=low

  * Initial release. (Closes: #1016908)

 -- Michel Alexandre Salim <michel@michel-slm.name>  Mon, 15 Aug 2022 10:32:28 -0500

=== debian/control ===
Source: zcfan
Section: utils
Priority: optional
Maintainer: Michel Alexandre Salim <michel@michel-slm.name>
Rules-Requires-Root: no
Build-Depends:
 debhelper-compat (= 13),
 pandoc,
Standards-Version: 4.6.2
Homepage: https://github.com/cdown/zcfan
Vcs-Browser: https://salsa.debian.org/michel/zcfan
Vcs-Git: https://salsa.debian.org/michel/zcfan.git

Package: zcfan
Architecture: linux-amd64 linux-i386
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Conflicts: thinkfan
Description: Zero-configuration fan daemon for ThinkPads
 zcfan is a zero-configuration fan control daemon for ThinkPads.

## zcfan 1.3.0

=== Makefile ===
CFLAGS:=-std=gnu99 -O2 -pedantic -Wall -Wextra -Wwrite-strings -Warray-bounds -Wconversion -Wstrict-prototypes -Werror $(CFLAGS)
CPPFLAGS:=$(CPPFLAGS)

SOURCES=$(wildcard *.c)
EXECUTABLES=$(patsubst %.c,%,$(SOURCES))

INSTALL:=install
prefix:=/usr/local
bindir:=$(prefix)/bin
datarootdir:=$(prefix)/share
mandir:=$(datarootdir)/man

all: $(EXECUTABLES)

%: %.c
	$(CC) $(CPPFLAGS) $(CFLAGS) $< -o $@ $(LIBS) $(LDFLAGS)

%.o: %.c
	$(CC) $(CPPFLAGS) $(CFLAGS) $< -c -o $@

%: %.o
	$(CC) $< -o $@ $(LIBS) $(LDFLAGS)

# Noisy clang build that's expected to fail, but can be useful to find corner
# cases.
clang-everything: CC=clang
clang-everything: CFLAGS+=-Weverything -Wno-disabled-macro-expansion -Wno-padded -Wno-covered-switch-default -Wno-gnu-zero-variadic-macro-arguments
clang-everything: all

sanitisers: CFLAGS+=-fsanitize=address -fsanitize=undefined -fanalyzer
sanitisers: debug

debug: CFLAGS+=-Og -ggdb -fno-omit-frame-pointer
debug: all

clang-tidy:
	# DeprecatedOrUnsafeBufferHandling: See https://stackoverflow.com/a/50724865/945780
	# clang-diagnostic-gnu-zero-variadic-macro-arguments: We require this for ##__VA_ARGS__
	clang-tidy zcfan.c -checks=-clang-analyzer-security.insecureAPI.DeprecatedOrUnsafeBufferHandling,-clang-diagnostic-gnu-zero-variadic-macro-arguments -- $(CPPFLAGS) $(CFLAGS) $(LDFLAGS)

install: all
	mkdir -p $(DESTDIR)$(bindir)/
	$(INSTALL) -pt $(DESTDIR)$(bindir)/ $(EXECUTABLES)
	$(INSTALL) -Dp -m 644 zcfan.service $(DESTDIR)$(prefix)/lib/systemd/system/zcfan.service
	$(INSTALL) -Dp -m 644 zcfan.1 $(DESTDIR)$(mandir)/man1/zcfan.1

lint:
	clang-format -style=file --dry-run --Werror zcfan.c

clean:
	rm -f $(EXECUTABLES)

=== debian/changelog ===
zcfan (1.3.0-1build1) noble; urgency=medium

  * No-change rebuild for CVE-2024-3094

 -- William Grant <wgrant@ubuntu.com>  Mon, 01 Apr 2024 19:43:25 +1100

zcfan (1.3.0-1) unstable; urgency=medium

  * New upstream version 1.3.0
  * Cleanup merged patch
  * Longer extended description

 -- Michel Lind <michel@michel-slm.name>  Mon, 04 Mar 2024 14:45:17 -0600

=== debian/control ===
--- 
+++ 
@@ -1,7 +1,8 @@
 Source: zcfan
 Section: utils
 Priority: optional
-Maintainer: Michel Alexandre Salim <michel@michel-slm.name>
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: Michel Alexandre Salim <michel@michel-slm.name>
 Rules-Requires-Root: no
 Build-Depends:
  debhelper-compat (= 13),
@@ -19,3 +20,14 @@
 Conflicts: thinkfan
 Description: Zero-configuration fan daemon for ThinkPads
  zcfan is a zero-configuration fan control daemon for ThinkPads.
+ .
+ Features:
+  - Extremely small (~250 lines), simple, and easy to understand code
+  - Sensible out of the box, configuration is optional (see "usage" below)
+  - Strong focus on stopping the fan as soon as safe to do so,
+    without inducing throttling
+  - Automatic temperature- and time-based hysteresis:
+    no bouncing between fan levels
+  - Watchdog support
+  - Minimal resource usage
+  - No dependencies

=== debian/rules ===
#!/usr/bin/make -f

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

%:
	dh $@

override_dh_auto_install:
	dh_auto_install -- prefix=/usr

override_dh_installinit:
	# we ship no initscripts

override_dh_installsystemd:
	# workaround for debhelper not supporting /usr/lib/systemd
	# https://bugs.debian.org/cgi-bin/bugreport.cgi?bug=1031695
	mv $(CURDIR)/debian/zcfan/usr/lib $(CURDIR)/debian/zcfan/
	# Do not enable by default on purpose
	# The user should only enable it after making sure the configuration is
	# appropriate for their computer
	dh_installsystemd --no-enable
	mv $(CURDIR)/debian/zcfan/lib $(CURDIR)/debian/zcfan/usr/

=== debian/watch ===
# See uscan(1) for format.

version=4

opts="filenamemangle=s%(?:.*?)?v?(\d[\d.]*)\.tar\.gz%zcfan-$1.tar.gz%" \
   https://github.com/cdown/zcfan/tags \
   (?:.*?/)?v?(\d[\d.]*)\.tar\.gz debian uupdate

## zcfan 1.4.0

=== Makefile ===
--- 
+++ 
@@ -10,7 +10,13 @@
 datarootdir:=$(prefix)/share
 mandir:=$(datarootdir)/man
 
-all: $(EXECUTABLES)
+SERVICE_TEMPLATE=zcfan.service.in
+SERVICE=zcfan.service
+
+all: $(EXECUTABLES) $(SERVICE)
+
+$(SERVICE): $(SERVICE_TEMPLATE)
+	sed 's|@bindir@|$(bindir)|g' $< > $@
 
 %: %.c
 	$(CC) $(CPPFLAGS) $(CFLAGS) $< -o $@ $(LIBS) $(LDFLAGS)
@@ -24,7 +30,7 @@
 # Noisy clang build that's expected to fail, but can be useful to find corner
 # cases.
 clang-everything: CC=clang
-clang-everything: CFLAGS+=-Weverything -Wno-disabled-macro-expansion -Wno-padded -Wno-covered-switch-default -Wno-gnu-zero-variadic-macro-arguments
+clang-everything: CFLAGS+=-Weverything -Wno-disabled-macro-expansion -Wno-padded -Wno-covered-switch-default -Wno-gnu-zero-variadic-macro-arguments -Wno-declaration-after-statement
 clang-everything: all
 
 sanitisers: CFLAGS+=-fsanitize=address -fsanitize=undefined -fanalyzer
@@ -41,11 +47,11 @@
 install: all
 	mkdir -p $(DESTDIR)$(bindir)/
 	$(INSTALL) -pt $(DESTDIR)$(bindir)/ $(EXECUTABLES)
-	$(INSTALL) -Dp -m 644 zcfan.service $(DESTDIR)$(prefix)/lib/systemd/system/zcfan.service
+	$(INSTALL) -Dp -m 644 $(SERVICE) $(DESTDIR)$(prefix)/lib/systemd/system/$(SERVICE)
 	$(INSTALL) -Dp -m 644 zcfan.1 $(DESTDIR)$(mandir)/man1/zcfan.1
 
 lint:
 	clang-format -style=file --dry-run --Werror zcfan.c
 
 clean:
-	rm -f $(EXECUTABLES)
+	rm -f $(EXECUTABLES) $(SERVICE)

=== debian/changelog ===
zcfan (1.4.0-2) unstable; urgency=high

  * Fix binary path in systemd unit (Closes: #1104811)

 -- Michel Lind <michel@michel-slm.name>  Tue, 13 May 2025 16:53:52 -0500

zcfan (1.4.0-1) unstable; urgency=medium

  * New upstream version 1.4.0
  * Update standards version to 4.7.0
  * Update maintainer's name due to legal name change

 -- Michel Lind <michel@michel-slm.name>  Mon, 30 Dec 2024 18:00:02 -0600

=== debian/control ===
--- 
+++ 
@@ -1,13 +1,12 @@
 Source: zcfan
 Section: utils
 Priority: optional
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: Michel Alexandre Salim <michel@michel-slm.name>
+Maintainer: Michel Lind <michel@michel-slm.name>
 Rules-Requires-Root: no
 Build-Depends:
  debhelper-compat (= 13),
  pandoc,
-Standards-Version: 4.6.2
+Standards-Version: 4.7.0
 Homepage: https://github.com/cdown/zcfan
 Vcs-Browser: https://salsa.debian.org/michel/zcfan
 Vcs-Git: https://salsa.debian.org/michel/zcfan.git

=== debian/rules ===
--- 
+++ 
@@ -4,6 +4,9 @@
 
 %:
 	dh $@
+
+override_dh_auto_build:
+	dh_auto_build -- prefix=/usr
 
 override_dh_auto_install:
 	dh_auto_install -- prefix=/usr
